$!-----------------------------------------------------------------------------
$! CREATE_SUPPORT_FILES.COM
$!
$! Ensure required files for certificate creation are present.
$! This procedure is very "quick-and-dirty", use with that in mind!
$!
$! 07-APR-2000  MGD  OPENSSL-0_9_6A
$! 10-DEC-2000  MGD  bugfix; open random seed file /append
$! 25-SEP-2000  MGD  OPENSSL-0_9_6
$! 05-MAR-2000  MGD  OPENSSL-0_9_5
$! 17-AUG-1999  MGD  refinement (OPENSSL-0_9_4)
$! 04-JUN-1999  MGD  OPENSSL-0_9_3 (adapted from earlier procedures)
$!-----------------------------------------------------------------------------
$!
$ if f$search("CERT.DIR;") .eqs. "" -
     then create /directory /protect=w [.CERT]
$ if f$search("[.CERT]WORK.DIR;") .eqs. "" -
     then create /directory /protect=w [.CERT.WORK]
$!
$ if f$search("[.CERT.WORK]WASD.RND;") .eqs. ""
$ then
$    create [.CERT.WORK]RAND.DAT /fdl=SYS$INPUT:
FILE
ORGANIZATION sequential
RECORD
CARRIAGE_CONTROL carriage_return
FORMAT stream_LF
$    open /append rnd [.CERT.WORK]RAND.DAT
$    randCount = 1000
$    randLoop:
$       write rnd randCount * f$integer(f$cvtime(,,"hundredth")), -
                  randCount * f$integer(f$cvtime(,,"second")), -
                  randCount + f$integer(f$cvtime(,,"second")), -
                  randCount + f$integer(f$cvtime(,,"hundredth"))
$       randCount = randCount - 1
$       if randCount .gt. 900 then goto randLoop
$!   endRandLoop:
$    close rnd
$    purge /nolog [.CERT.WORK]RAND.DAT
$ endif
$ RANDFILE == f$parse("[.CERT.WORK]RAND.DAT")
$!
$ if f$search("[.CERT.WORK]INDEX.TXT;") .eqs. ""
$ then
$    create [.CERT.WORK]INDEX.TXT; /fdl=SYS$INPUT:
FILE
ORGANIZATION sequential
RECORD
CARRIAGE_CONTROL carriage_return
FORMAT stream_LF
$ endif
$!
$ if f$search("[.CERT.WORK]SERIAL.TXT;") .eqs. ""
$ then
$    create [.CERT.WORK]SERIAL.TXT; /fdl=SYS$INPUT: 
FILE
ORGANIZATION sequential
RECORD
CARRIAGE_CONTROL carriage_return
FORMAT stream_LF
$    open /append file [.CERT.WORK]SERIAL.TXT;
$    write file "0001"
$    close file
$ endif
$!
$!-----------------------------------------------------------------------------
